SignatureSpi
Date: 2016-06-24

java.security

## Class SignatureSpi

- java.lang.Object
- - java.security.SignatureSpi

- Direct Known Subclasses:
    Signature

      public abstract class SignatureSpi
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SecureRandom` | `appRandom`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SignatureSpi()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `clone()`
    `protected AlgorithmParameters` | `engineGetParameters()`
    `protected abstract void` | `engineInitSign(PrivateKey var0)`
    `protected void` | `engineInitSign(PrivateKey var0, SecureRandom var1)`
    `protected abstract void` | `engineInitVerify(PublicKey var0)`
    `protected void` | `engineSetParameter(AlgorithmParameterSpec var0)`
    `protected abstract byte[]` | `engineSign()`
    `protected int` | `engineSign(byte[] var0, int var1, int var2)`
    `protected abstract void` | `engineUpdate(byte var0)`
    `protected abstract void` | `engineUpdate(byte[] var0, int var1, int var2)`
    `protected abstract boolean` | `engineVerify(byte[] var0)`
    `protected boolean` | `engineVerify(byte[] var0, int var1, int var2)`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### appRandom

          protected SecureRandom appRandom

  - ### Constructor Detail

    - #### SignatureSpi

          public SignatureSpi()

  - ### Method Detail

    - #### clone

          public Object clone()
                       throws CloneNotSupportedException

      Overrides:
        `clone` in class `Object`
      Throws:
        `CloneNotSupportedException`

    - #### engineGetParameters

          protected AlgorithmParameters engineGetParameters()

    - #### engineInitSign

          protected abstract void engineInitSign(PrivateKey var0)
                                          throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### engineInitSign

          protected void engineInitSign(PrivateKey var0,
                            SecureRandom var1)
                                 throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### engineInitVerify

          protected abstract void engineInitVerify(PublicKey var0)
                                            throws InvalidKeyException

      Throws:
        `InvalidKeyException`

    - #### engineSetParameter

          protected void engineSetParameter(AlgorithmParameterSpec var0)
                                     throws InvalidAlgorithmParameterException

      Throws:
        `InvalidAlgorithmParameterException`

    - #### engineSign

          protected abstract byte[] engineSign()
                                        throws SignatureException

      Throws:
        `SignatureException`

    - #### engineSign

          protected int engineSign(byte[] var0,
                       int var1,
                       int var2)
                            throws SignatureException

      Throws:
        `SignatureException`

    - #### engineUpdate

          protected abstract void engineUpdate(byte var0)
                                        throws SignatureException

      Throws:
        `SignatureException`

    - #### engineUpdate

          protected abstract void engineUpdate(byte[] var0,
                          int var1,
                          int var2)
                                        throws SignatureException

      Throws:
        `SignatureException`

    - #### engineVerify

          protected abstract boolean engineVerify(byte[] var0)
                                           throws SignatureException

      Throws:
        `SignatureException`

    - #### engineVerify

          protected boolean engineVerify(byte[] var0,
                             int var1,
                             int var2)
                                  throws SignatureException

      Throws:
        `SignatureException`